	org $1001-2
	dw  $1001
	
	dw nextln,0	; second word is line number
	db $9E,"4109",0
nextln	db 0,0

start
	sei
	sta $ff3f
	jmp skip_compressed_data
decompress
	include "intro_comp1_hex.asm"
	include "intro_comp2_hex.asm"
	db 0,0,0

skip_compressed_data
	ldx #$00
	stx $02				; "skip everything" flag
fs1	lda irq,x
	sta $0500,x
	inx
	bne fs1
	;
	lda #$01
	sta $FF11
	lda #$FE
	sta $FF0E
	sta $FF0F
	lda #$03
	sta $FF10
	lda $FF12
	and #$FC
	ora #$03
	sta $FF12
	;
	stx $FFFE
	lda #$05
	sta $FFFF
	lda #$CC
	sta $FF0B
	;
	lda $FF07
	and #$40
	beq pal
	;
	lda #($0500+(pos_ntsc-irq)) & 255
	sta $0516
	sta $0529
	;
pal	cli
	;
	jmp decompress
	
irq	pha
	txa
	pha
	tya
	pha
	;
	lda #$00
	sta $D0
	sta $D2
	lda #$08
	sta $D1
	lda #$0C
	sta $D3
	;
	ldx #24
	;
xl	lda $0500+(pos_pal-irq),x
	cmp #$28
	bcs nodraw
	;
	tay
	lda $FF19
	and #$7F
	sta ($D0),y
	lda #$A0
	sta ($D2),y
	;
nodraw
	dec $0500+(pos_pal-irq),x
	;
	lda $D0
	clc
	adc #40
	sta $D0
	sta $D2
	bcc *+6
	inc $D1
	inc $D3
	;
	dex
	bpl xl
	;
	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10			; Query keyboard for "Space"
	bne not_pressed
	;
	lda #$FF
	sta $02
	lda #$0B
	sta $FF06
	;
not_pressed
	asl $FF09
	pla
	tay
	pla
	tax
	pla
	rti

pos_pal
	db 54, 152, 164, 131, 90
	db 39, 115, 95, 146, 79
	db 110, 120, 136, 141, 74
	db 59, 49, 126, 170, 44
	db 64, 105, 158, 85, 69
pos_ntsc
	db 61, 201, 218, 171, 112
	db 39, 148, 119, 193, 96
	db 141, 155, 178, 185, 89
	db 68, 53, 164, 227, 46
	db 75, 134, 210, 105, 82
;eof