	org $1001-2
	dw  $1001
	
	dw nextln,0	; second word is line number
	db $9E,"4109",0
nextln	db 0,0
	
	jmp start

sounds_start
	include "sounds.asm"
sounds_end

print_byte
	pha
	lsr a
	lsr a
	lsr a
	lsr a
	jsr print_digit
	;
	pla
	and #$0F
	;
print_digit
	tax
	lda hex_char,x
	cmp #7
	bcs pd1
	clc
	adc #$40
pd1	jmp $FFD2

hex_char
	db "0123456789",1,2,3,4,5,6

Print16	macro addr
	lda #"$"
	jsr $FFD2
	lda #addr >> 8
	jsr print_byte
	;
	lda #addr & 255
	jsr print_byte
	endm
	
start	jsr $FF4F
	db "INTO THE EAGLE'S NEST DELUXE SOUNDS",$0D,$0D
	db "MEMORY: ",0
	Print16 sounds_start
	lda #"-"
	jsr $FFD2
	Print16 sounds_end
	jsr $FF4F
	db " (",0
	Print16 (sounds_end - sounds_start)
	jsr $FF4F
	db " BYTES)",$0D,$0D,0
	;
	jsr $FF4F
	db "PRESS",$0D
	db "[0] OFF",$0D
	db "[1] ITEM PICKUP",$0D
	db "[2] AMMO ALERT",$0D
	db "[3] METAL DOOR",$0D
	db "[4] HEAL",$0D
	db "[5] SHOOT",$0D   
	db "[6] DOOR OPEN",$0D
	db "[7] EXPLOSION",$0D
	db "[8] HIT",$0D
	db "[9] DESTROYED",$0D
	db 0
	;
	sei
	sta $FF3F
	lda #$CB
	sta $FF0B
	lda #irq & 255
	sta $FFFE
	lda #irq >> 8
	sta $FFFF
	;
	lda #$00
	sta VAR_SOUND_REQUESTED
	sta VAR_SOUND_CURRENT
	;
	;lda #SND_OFF
	;jsr sound_set				; init
	;
	;lda #20*9				; volume off value
	;sta VOLUME				; VOLUME (of music player)
	;
	cli
	;
loop
	ldy #$00
	;
loop1	lda key_data_1,y
	sta $FD30
	sta $FF08
	lda $FF08
	and key_data_2,y
	bne not_pressed
	;
wait_for_key_release
	lda key_data_1,y
	sta $FD30
	sta $FF08
	lda $FF08
	and key_data_2,y
	beq wait_for_key_release 
	;
	lda key_data_3,y
;	bne ss3
;	;
;	lda sound_player_dead
;	eor #$FF
;	sta sound_player_dead
;	jmp not_pressed
;	;
;ss3	
;	cmp #$03
;	bne ss2
;	;
;	lda sound_player_falling
;	eor #$FF
;	sta sound_player_falling
;	jmp not_pressed
;	;
;ss2	
	;jsr sound_set
	sta VAR_SOUND_REQUESTED
	;
not_pressed	
	iny
	cpy #(key_data_2 - key_data_1)
	bne loop1
	;
	jmp loop
	
key_data_1
	db $EF,$7F,$7F,$FD,$FD,$FB,$FB,$F7	; 0-7
	db $F7,$EF				; 8-9
	db $DF
	db $FD,$F7,$FB,$FB,$FD,$FB,$F7,$F7,$EF	; A-I
	db $EF,$EF,$DF,$EF,$EF,$EF,$DF,$7F,$FB	; J-R
	db $FD					; S
key_data_2
	db $08,$01,$08,$01,$08,$01,$08,$01	; 0-7
	db $08,$01
	db $40
	db $04,$10,$10,$04,$40,$20,$04,$20,$02	; A-I
	db $04,$20,$04,$10,$80,$40,$02,$40,$02	; J-R
	db $20					; S 
key_data_3
	db $00,$01,$02,$03,$04,$05,$06,$07
	db $08,$09
	db $00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00
		
irq
	pha
	txa
	pha
	tya
	pha
	;
	lda $FF19
	eor #$66
	sta $FF19
	;
	jsr LAB_PLAY_SOUND
	;
	lda $FF19
	eor #$66
	sta $FF19
	;
;	sta $FF3E
;	lda $FF10
;	and #$03
;	jsr print_byte
;	lda $FF0F
;	jsr print_byte
;	lda #$20
;	jsr $FFD2
;	lda $FF12
;	and #$03
;	jsr print_byte
;	lda $FF0E
;	jsr print_byte
;	lda #$0D
;	jsr $FFD2
;	sta $FF3F
	;
	asl $FF09
	pla
	tay
	pla
	tax
	pla
	rti
;eof	