	org $1001-2
	dw $1001
	
	dw $100B
	dw 2020
	db $9E,"4352"
	db 0,0,0
	db 0,0,0
	
	db "TEDMUSIC"
	
	db 0		; ver
	
	dw music_beg-$1001+2	; data offset
	
	dw music_beg	; data address
	
	dw MUSIC_PLAYER_INIT
	
	dw MUSIC_PLAYER
	
	db 1		; songs
	
	db 2		; timing: pal/timer
	
	dw 8867		; timing: 8867
	
	db 0		; flags
	
	ds 26		; reserved
	
	   ;01234567012345670123456701234567
	db "INTO THE EAGLE'S NEST           "
	db "CSABO/LOD                       "
	db "2023                            "
	
	db 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	db 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	db 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	db 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	db 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	db 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
	
temp	= $D0	
dest	= $D2
	;
time		= $0D49
max_raster	= time + 47
max_raster_chr	= time + 40
track_info	= $0E17 - 40
regs_info	= $0DC1
volume_info	= $0E82

charput		= $FFD2

PrintTx macro addr
	ldx #$00
	lda addr,x
	beq *+8
	jsr charput
	inx
	bne *-9
	endm

Print16	macro addr
	lda #"$"
	jsr charput
	lda #addr >> 8
	jsr print_byte
	;
	lda #addr & 255
	jsr print_byte
	endm
	
start	
	lda #$93
	jsr charput
	ldx #$00
	lda $1040,x		; title
	jsr charput
	inx
	cpx #32
	bne *-9
	;
	lda #$0D
	jsr charput
	;
	ldx #32
fe1	dex
	lda $105F,x
	cmp #$20
	beq fe1
	;
	ldy #$00
wr2	lda $1060,y
	jsr charput
	iny
	dex
	bpl wr2
	;
	ldx #32
fe2	dex
	lda $1080,x
	cmp #$20
	beq fe2
	;
	ldy #$00
wr3	lda $1080,y
	jsr charput
	iny
	dex
	bpl wr3
	;
	;
	;
	PrintTx txt2
	Print16 music_beg
        PrintTx txt3
	Print16 music_end
	PrintTx txt4
	;
	sei
	sta $FF3F
	;
	; ---
	;
	lda #$41
	sta $FF19
	lda #$51
	sta $FF15
	;
	; ---
	;
restart_song
	ldy #$00
	sty $FF11
	;
	ldx #$00
delay	inx
	bne delay
	iny
	bne delay
	;
	jsr MUSIC_PLAYER_INIT
	;
	lda #$30			; "0"
	sta time
	sta time+1
	sta time+3
	sta time+4
	;
	lda #$00
	sta time+7
	sta max_raster
	;
	; ----------
	;
main
	lda $FF1D
	and #$F8
	cmp #$C8
	beq go_1
	;
sync0	lda #$BF			; check keyboard for "cursor right"
	sta $FD30
	sta $FF08
	lda $FF08
	and #$08
	bne main
	;
	inc $FF19			; fast forward
	jsr MUSIC_PLAYER
	jsr inc_timer
	dec $FF19
	jmp main
	;
go_1	
	dec $FF19
	lda $FF1D
	sta r_start+1
	;
	jsr MUSIC_PLAYER
	;
	inc $FF19
	;
	lda $FF1D
	sec
r_start	sbc #$00
	cmp max_raster
	bcc not_larger
	;
	sta max_raster
	;
	and #$0F
	tax
	lda hex_char,x
	sta max_raster_chr+1
	;
	lda max_raster
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	lda hex_char,x
	sta max_raster_chr
	;
not_larger
	;
	jsr inc_timer
	jsr dump_registers
	;
sync1	lda $FF1D
	and #$F8
	cmp #$C8
	beq sync1
	;
	jmp main
	
inc_timer
	lda time+7
	clc
	adc #$01
	cmp #50
	bne inc1
	;
	ldx #$05
inc2	dex 
	cpx #$02
	beq inc2
	lda time,x
	clc
	adc #$01
	cmp time_end,x
	bne inc3
	lda #$30
inc3	sta time,x
	cmp #$30
	beq inc2
	;
	lda #$00
inc1	sta time+7
	;
	rts
time_end
	db $3A,$3A,$3A,$36,$3A
hex_char
	db "0123456789",1,2,3,4,5,6
	
dump_registers
	lda #(regs_info + 0*40 & 255)
	sta dest
	lda #(regs_info + 0*40 >> 8)
	sta dest+1
	;
	ldx $FF0E
	lda $FF12
	and #$03
	jsr write_word
	;
	lda #(regs_info + 1*40 & 255)
	sta dest
	lda #(regs_info + 1*40 >> 8)
	sta dest+1
	;
	ldx $FF0F
	lda $FF10
	and #$03
	jsr write_word
	;
	lda #(regs_info + 2*40 & 255)
	sta dest
	lda #(regs_info + 2*40 >> 8)
	sta dest+1
	;
	lda $FF11
	and #$0F
	jsr write_byte
	;
	lda #(regs_info + 3*40 & 255)
	sta dest
	lda #(regs_info + 3*40 >> 8)
	sta dest+1
	;
	lda $FF11
	and #$40
	jsr write_byte
	;
	rts	
	;
	; A,X = hex value to print (hi,lo)
	;
write_word
	stx x_sav2+1
	jsr write_byte
x_sav2	lda #$00
	;
	; A = hex value to print
	;
write_byte
	sty y_save+1
	pha
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	lda hex_char,x
	ldy #$00
	sta (dest),y
	pla
	and #$0F
	tax
	lda hex_char,x
	iny
	sta (dest),y
	;
	lda #$02
	jsr add_dest
y_save	ldy #$00
	rts

add_dest_1
	lda #$01
add_dest
	clc
	adc dest
	sta dest
	bcc *+4
	inc dest+1
	rts
	
print_byte
	pha
	lsr a
	lsr a
	lsr a
	lsr a
	jsr print_digit
	;
	pla
	and #$0F
	;
print_digit
	tax
	lda hex_char,x
	cmp #7
	bcs pd1
	clc
	adc #$40
pd1	jmp charput
	
txt2	db $0D,$0D,$0D,$0D,$0D,$0D,$0D
	db "TIME   : 00:00 ( )",$0D
	db "RASTER :       ( )",$0D
	db "MUSIC  : "
	db 0

txt3
	db " - ",0

txt4
	;db " ($CEFF)"
	db $0D
	db "FREQ 1 : ",$0D
	db "FREQ 2 : ",$0D
	db "VOLUME : ",$0D
	db "NOISE  : ",$0D,$0D
	;
;	db "8:",$0D
;	db "7:",$0D
;	db "6:",$0D
;	db "5:",$0D
;	db "4:",$0D
;	db "3:",$0D
;	db "2:",$0D
;	db "1:",$0D
;	db "0:"
	db 0
	
	align 256
music_beg
	include "music.asm"
music_end
;[eof]